//+------------------------------------------------------------------------
//
//  Copyright @ Baris TAZE
//
//  File:     Bit.cpp
//
//  Content:  implementation of the CBit class.
//  
//  Classes:  CBit
//            
//  History:  27-May-2002    created by baris taze .  
//
//-------------------------------------------------------------------------

#include "stdafx.h"
#include "Bit.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Function Name:	Constructor	
// Parameters	:	void
// Return Type	:	void
// Description	:	Constructor	
// Assumptions	:	No Assumption
CBit::CBit()
{
	m_bValue  = false;
	m_bLocked = false;
}

//////////////////////////////////////////////////////////////////////
// Function Name:	Destructor	
// Parameters	:	void
// Return Type	:	void
// Description	:	Destructor	
// Assumptions	:	No Assumption
CBit::~CBit()
{

}

//////////////////////////////////////////////////////////////////////
// Function Name:	Constructor	
// Parameters	:	bool bValue, bit value: true(bit-1), false(bit-0)
// Return Type	:	void
// Description	:	Constructor	
// Assumptions	:	No Assumption
CBit::CBit( bool bValue )
{
	m_bValue  = bValue;
	m_bLocked = false;
}

//////////////////////////////////////////////////////////////////////
// Function Name:	IsEqual ( virtual function: have to be override )	
// Parameters	:	CBit* pBit, to be checked for equality
// Return Type	:	bool
// Description	:	checks whether to the values of each bit is equal or not.
// Assumptions	:	No Assumption
bool CBit::IsEqual( CBit* pBit )
{
	ASSERT( NULL != pBit );

	return( GetValue() == pBit->GetValue() );
}

//////////////////////////////////////////////////////////////////////
// Function Name:	SetValue
// Parameters	:	bool bValue, bit value, refers to 0 or 1.
// Return Type	:	void
// Description	:	sets the bit value of this object
// Assumptions	:	No Assumption	
void CBit::SetValue( bool bValue )
{
	m_bValue = bValue;
}

//////////////////////////////////////////////////////////////////////
// Function Name:	GetValue
// Parameters	:	void
// Return Type	:	bool bValue, bit value, refers to 0 or 1.
// Description	:	returns the bit value of this object
// Assumptions	:	No Assumption	
bool CBit::GetValue( )
{
	return m_bValue;
}

//////////////////////////////////////////////////////////////////////
// Function Name:	Lock
// Parameters	:	void
// Return Type	:	void
// Description	:	Sets the "lock state" of this object as true.
// Assumptions	:	No Assumption	
void CBit::Lock()
{
	m_bLocked = true;
}

//////////////////////////////////////////////////////////////////////
// Function Name:	Unlock
// Parameters	:	void
// Return Type	:	void
// Description	:	Sets the "lock state" of this object as false.
// Assumptions	:	No Assumption	
void CBit::Unlock()
{
	m_bLocked = false;	
}

//////////////////////////////////////////////////////////////////////
// Function Name:	IsLocked
// Parameters	:	void
// Return Type	:	bool 
// Description	:	Returns the "lock state" of this object.
// Assumptions	:	No Assumption	
bool CBit::IsLocked()
{
	return m_bLocked;
}

//////////////////////////////////////////////////////////////////////
// Function Name:	Mutate
// Parameters	:	void
// Return Type	:	void 
// Description	:	Swap the bit value [ from 1 to 0, or 0 to 1 ]
// Assumptions	:	No Assumption	
void CBit::Mutate()
{
	m_bValue = !m_bValue;
}

//////////////////////////////////////////////////////////////////////
// Function Name:	ToString
// Parameters	:	void
// Return Type	:	CRtring
// Description	:	Returns the bit as a text, i.e. "0" or "1";
// Assumptions	:	No Assumption	
CString CBit::ToString()
{
	CString temp("0");

	if( m_bValue )
	{
		temp = "1";
	}
	
	return temp;
}